local aName, aObj = ...
if not aObj.isClassic then return end
local _G = _G

local pairs, ipairs = _G.pairs, _G.ipairs

local ftype
local funcs= {
	NPC = {
		{ name = "AlliedRacesUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "AuctionUI", type = "LoD", keep = false, keepOpts = true },
		{ name = "AzeriteRespecUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "BankFrame", type = "", keep = false, keepOpts = true },
		{ name = "BarbershopUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "BlackMarketUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "FlightMap", type = "LoD", keep = false, keepOpts = false },
		{ name = "GossipFrame", type = "", keep = true, keepOpts = true },
		{ name = "GuildRegistrar", type = "", keep = true, keepOpts = true },
		{ name = "ItemUpgradeUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "MerchantFrame", type = "", keep = true, keepOpts = true },
		{ name = "Petition", type = "LoD", keep = true, keepOpts = true },
		{ name = "PetStableFrame", type = "", keep = false, keepOpts = true },
		{ name = "QuestChoice", type = "LoD", keep = false, keepOpts = false },
		{ name = "QuestFrame", type = "", keep = true, keepOpts = true },
		{ name = "QuestInfo", type = "", keep = true, keepOpts = true },
		{ name = "Tabard", type = "", keep = true, keepOpts = true },
		{ name = "TaxiFrame", type = "", keep = true, keepOpts = true },
		{ name = "TrainerUI", type = "LoD", keep = false, keepOpts = true },
		{ name = "VoidStorageUI", type = "LoD", keep = false, keepOpts = false },
	},
	Player = {
		{ name = "AchievementUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "ArchaeologyUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "ArenaUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "ArtifactUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "AzeriteEssenceUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "AzeriteUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "Buffs", type = "", keep = true, keepOpts = true },
		{ name = "CastingBar", type = "", keep = true, keepOpts = true },
		{ name = "CharacterFrames", type = "", keep = false, keepOpts = true },
		{ name = "Collections", type = "LoD", keep = false, keepOpts = false },
		{ name = "Communities", type = "LoD", keep = false, keepOpts = false },
		{ name = "CompactFrames", type = "", keep = true, keepOpts = true },
		{ name = "ContainerFrames", type = "", keep = false, keepOpts = true },
		{ name = "DressUpFrame", type = "", keep = true, keepOpts = true },
		{ name = "EncounterJournal", type = "LoD", keep = false, keepOpts = false },
		{ name = "EquipmentFlyout", type = "", keep = false, keepOpts = false },
		{ name = "FriendsFrame", type = "", keep = false, keepOpts = true },
		{ name = "GuildControlUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "GuildInvite", type = "", keep = false, keepOpts = false },
		{ name = "GuildUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "InspectUI", type = "LoD", keep = true, keepOpts = true },
		{ name = "ItemSocketingUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "LookingForGuildUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "LootFrames", type = "", keep = true, keepOpts = true },
		{ name = "LootHistory", type = "", keep = false, keepOpts = false },
		{ name = "MirrorTimers", type = "", keep = true, keepOpts = true },
		{ name = "ModelFrames", type = "", keep = true, keepOpts = true },
		{ name = "ObjectiveTracker", type = "", keep = false, keepOpts = false },
		{ name = "OverrideActionBar", type = "", keep = false, keepOpts = false },
		{ name = "PVPHonorSystem", type = "", keep = false, keepOpts = false },
		{ name = "PVPUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "RaidUI", type = "LoD", keep = true, keepOpts = true },
		{ name = "ReadyCheck", type = "", keep = true, keepOpts = true },
		{ name = "RolePollPopup", type = "", keep = false, keepOpts = false },
		{ name = "SpellBookFrame", type = "", keep = true, keepOpts = true },
		{ name = "StackSplit", type = "", keep = true, keepOpts = true },
		{ name = "TalentUI", type = "LoD", keep = false, keepOpts = true },
		{ name = "TradeFrame", type = "", keep = true, keepOpts = true },
		{ name = "TradeSkillUI", type = "LoD", keep = false, keepOpts = true },
		{ name = "WardrobeOutfits", type = "", keep = false, keepOpts = false },
	},
	UI = {
		{ name = "AddonList", type = "", keep = true, keepOpts = true },
		{ name = "AdventureMap", type = "LoD", keep = false, keepOpts = false },
		{ name = "AlertFrames", type = "", keep = false, keepOpts = false },
		{ name = "ArtifactToasts", type = "", keep = false, keepOpts = false },
		{ name = "AutoComplete", type = "", keep = false, keepOpts = false },
		{ name = "BattlefieldMap", type = "LoD", keep = false, keepOpts = false },
		{ name = "BindingUI", type = "LoD", keep = true, keepOpts = true },
		{ name = "BNFrames", type = "", keep = true, keepOpts = true },
		{ name = "Calendar", type = "LoD", keep = false, keepOpts = false },
		{ name = "ChallengesUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "ChatBubbles", type = "", keep = true, keepOpts = true },
		{ name = "ChatButtons", type = "", keep = false, keepOpts = true },
		{ name = "ChatConfig", type = "", keep = true, keepOpts = true },
		{ name = "ChatEditBox", type = "", keep = true, keepOpts = true },
		{ name = "ChatFrames", type = "", keep = true, keepOpts = true },
		{ name = "ChatMenus", type = "", keep = true, keepOpts = true },
		{ name = "ChatMinimizedFrames", type = "", keep = false, keepOpts = false },
		{ name = "ChatTabs", type = "", keep = true, keepOpts = true },
		{ name = "ChatTemporaryWindow", type = "", keep = false, keepOpts = false },
		{ name = "CinematicFrame", type = "", keep = true, keepOpts = true },
		{ name = "ClassTrial", type = "LoD", keep = false, keepOpts = false },
		{ name = "CoinPickup", type = "", keep = true, keepOpts = true },
		{ name = "ColorPicker", type = "", keep = true, keepOpts = true },
		{ name = "Console", type = "", keep = false, keepOpts = false },
		{ name = "Contribution", type = "LoD", keep = false, keepOpts = false },
		{ name = "DeathRecap", type = "LoD", keep = false, keepOpts = false },
		{ name = "DebugTools", type = "LoD", keep = true, keepOpts = true },
		{ name = "DestinyFrame", type = "", keep = false, keepOpts = false },
		{ name = "GarrisonTooltips", type = "", keep = false, keepOpts = false },
		{ name = "GarrisonUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "GhostFrame", type = "", keep = false, keepOpts = false },
		{ name = "GMChatUI", type = "LoD", keep = true, keepOpts = true },
		{ name = "GMSurveyUI", type = "LoD", keep = true, keepOpts = true },
		{ name = "GuildBankUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "HelpFrame", type = "", keep = true, keepOpts = true },
		{ name = "IslandsPartyPoseUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "IslandsQueueUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "ItemText", type = "", keep = true, keepOpts = true },
		{ name = "LevelUpDisplay", type = "", keep = false, keepOpts = false },
		{ name = "LFDFrame", type = "", keep = false, keepOpts = false },
		{ name = "LFGFrame", type = "", keep = false, keepOpts = false },
		{ name = "LFGList", type = "", keep = false, keepOpts = false },
		{ name = "LFRFrame", type = "", keep = false, keepOpts = false },
		{ name = "LossOfControl", type = "", keep = false, keepOpts = false },
		{ name = "MacroUI", type = "LoD", keep = true, keepOpts = true },
		{ name = "MailFrame", type = "", keep = true, keepOpts = true },
		{ name = "MainMenuBar", type = "", keep = false, keepOpts = true },
		{ name = "MenuFrames", type = "", keep = true, keepOpts = true },
		{ name = "Minimap", type = "", keep = true, keepOpts = true },
		{ name = "MinimapButtons", type = "", keep = true, keepOpts = true },
		{ name = "MovePad", type = "LoD", keep = true, keepOpts = true },
		{ name = "MovieFrame", type = "", keep = true, keepOpts = true },
		{ name = "NamePlates", type = "", keep = true, keepOpts = true },
		{ name = "NavigationBar", type = "", keep = false, keepOpts = false },
		{ name = "ObliterumUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "OrderHallUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "PetBattleUI", type = "", keep = false, keepOpts = false },
		{ name = "ProductChoiceFrame", type = "", keep = true, keepOpts = true },
		{ name = "PVEFrame", type = "", keep = false, keepOpts = false },
		{ name = "PVPHelper", type = "", keep = false, keepOpts = false },
		{ name = "PVPMatch", type = "", keep = false, keepOpts = false },
		{ name = "QuestMap", type = "", keep = false, keepOpts = false },
		{ name = "QueueStatusFrame", type = "", keep = false, keepOpts = false },
		{ name = "RaidFinder", type = "", keep = false, keepOpts = false },
		{ name = "RaidFrame", type = "", keep = true, keepOpts = true },
		{ name = "ScenarioFinder", type = "", keep = false, keepOpts = false },
		{ name = "ScrappingMachineUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "SharedBasicControls", type = "", keep = false, keepOpts = false },
		{ name = "SplashFrame", type = "", keep = false, keepOpts = false },
		{ name = "StaticPopups", type = "", keep = true, keepOpts = true },
		{ name = "StaticPopupSpecial", type = "", keep = false, keepOpts = false },
		{ name = "TalkingHeadUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "TimeManager", type = "", keep = true, keepOpts = true },
		{ name = "Tooltips", type = "", keep = true, keepOpts = true },
		{ name = "Tutorial", type = "", keep = false, keepOpts = true },
		{ name = "UIDropDownMenu", type = "", keep = true, keepOpts = true },
		{ name = "UIWidgets", type = "", keep = true, keepOpts = true },
		{ name = "UnitPopup", type = "", keep = true, keepOpts = true },
		{ name = "WarboardUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "WarfrontsPartyPoseUI", type = "LoD", keep = false, keepOpts = false },
		{ name = "WorldMap", type = "", keep = false, keepOpts = true },
		{ name = "ZoneAbility", type = "", keep = false, keepOpts = false },
	},
}
aObj.otherAddons.ClassicInit = function(self)

	-- NOP functions that are not required and cause errors
	self.removeNineSlice = _G.nop
	self.skinGlowBox = _G.nop

	-- remove code for frames that don't exist
	local function removeFunc(name, ftype, type, keep)
		-- aObj:Debug("removeFunc: [%s, %s, %s]", name, ftype, type, keep)
		if keep then return end
		if type == "LoD" then
			aObj.blizzLoDFrames[ftype][name] = nil
		else
			aObj.blizzFrames[ftype][name] = nil
		end
	end

	for fType, tTab in pairs(funcs) do
		-- aObj:Debug("ClassicInit: [%s, %s]", fType, tTab)
		for _, fTab in ipairs(tTab) do
			removeFunc(fTab.name, fType:sub(1, 1):lower(), fTab.type, fTab.keep)
		end
	end

	-- remove options for frames that don't exist
	local function removeOpts(name, ftype, keepOpts)
		-- aObj:Debug("removeOpts: [%s, %s, %s]", name, ftype, keepOpts)
		if not keepOpts then
			aObj.db.profile[name] = nil
			aObj.db.defaults.profile[name] = nil
			aObj.optTables[ftype].args[name] = nil
		end
	end

	self:SecureHook(self.blizzFrames.opt, "SetupOptions", function(this)
		for fType, tTab in pairs(funcs) do
			for _, fTab in ipairs(tTab) do
				removeOpts(fTab.name, fType .. " Frames", fTab.keepOpts)
			end
		end

		-- remove unused sub-options here
		self.db.profile.MainMenuBar.extraab = nil
		self.db.profile.MainMenuBar.altpowerbar = nil
		self.db.defaults.profile.MainMenuBar.extraab = nil
		self.db.defaults.profile.MainMenuBar.altpowerbar = nil
		self.optTables["UI Frames"].args.MainMenuBar.args.extraab = nil
		self.optTables["UI Frames"].args.MainMenuBar.args.altpowerbar = nil

		-- remove module options
		for k, prof in pairs(self.db.sv.namespaces["UnitFrames"].profiles) do
			prof.focus = nil
			prof.arena = nil
		end
		self.optTables["Modules"].args[aName .. "_UnitFrames"].args.focus = nil
		self.optTables["Modules"].args[aName .. "_UnitFrames"].args.arena = nil

		-- Add options for new frames
		self.db.profile.CraftUI = true
		self.db.defaults.profile.CraftUI = true
		self.optTables["Player Frames"].args.CraftUI = {
			type = "toggle",
			name = self.L["CraftUI"],
			desc = self.L["Toggle the skin of the CraftUI"],
		}
		self.db.profile.BattlefieldFrame = true
		self.db.defaults.profile.BattlefieldFrame = true
		self.optTables["UI Frames"].args.BattlefieldFrame = {
			type = "toggle",
			name = self.L["Battlefield Frame"],
			desc = self.L["Toggle the skin of the Battlefield Frame"],
		}
		self.db.profile.QuestLog = true
		self.db.defaults.profile.QuestLog = true
		self.optTables["UI Frames"].args.QuestLog = {
			type = "toggle",
			name = self.L["Quest Log"],
			desc = self.L["Toggle the skin of the Quest Log"],
		}
		self.db.profile.QuestTimer = true
		self.db.defaults.profile.QuestTimer = true
		self.optTables["UI Frames"].args.QuestTimer = {
			type = "toggle",
			name = self.L["Quest Timer"],
			desc = self.L["Toggle the skin of the Quest Timer"],
		}

		self:Unhook(this, "SetupOptions")
	end)

	_G.collectgarbage("collect")

	-- add/replace code for frames that do exist

	ftype = "n"
	self.blizzLoDFrames[ftype].AuctionUI = function(self)
		if not self.prdb.AuctionUI or self.initialized.AuctionUI then return end
		self.initialized.AuctionUI = true

		local function skinBtn(btnName, idx)
			aObj:keepFontStrings(_G[btnName .. idx])
			_G[btnName .. idx .. "Highlight"]:SetAlpha(1)
			_G[btnName .. idx .. "ItemNormalTexture"]:SetAlpha(0) -- texture changed in code
			if aObj.modBtnBs then
				aObj:addButtonBorder{obj=_G[btnName .. idx .. "Item"], reParent={_G[btnName .. idx .. "Count"], _G[btnName .. idx .. "Stock"]}}
				aObj:clrButtonBorder(_G[btnName .. idx .. "Item"])
			end
		end

		self:SecureHookScript(_G.AuctionFrame, "OnShow", function(this)
			-- hide filter texture when filter is clicked
			self:SecureHook("FilterButton_SetUp", function(button, ...)
				_G[button:GetName() .. "NormalTexture"]:SetAlpha(0)
			end)

			self:skinTabs{obj=this, lod=true}
			self:addSkinFrame{obj=_G.AuctionFrame, ft=ftype, kfs=true, hdr=true, x1=10, y1=-11, y2=5}
			self:moveObject{obj=_G.AuctionFrameCloseButton, x=3}

			-- AuctionFrame Browse
			for i = 1, _G.NUM_FILTERS_TO_DISPLAY do
				self:keepRegions(_G["AuctionFilterButton" .. i], {3, 4}) -- N.B. region 3 is the highlight, 4 is the text
				self:addSkinFrame{obj=_G["AuctionFilterButton" .. i], ft=ftype, nb=true, aso={bd=5}, y2=-1}
			end
			self:skinSlider{obj=_G.BrowseFilterScrollFrame.ScrollBar, rt="artwork"}
			self:skinSlider{obj=_G.BrowseScrollFrame.ScrollBar, rt="artwork"}
			for _, type in pairs{"Quality", "Level", "Duration", "HighBidder", "CurrentBid"} do
				self:keepRegions(_G["Browse" .. type .. "Sort"], {4, 5, 6}) -- N.B. region 4 is the text, 5 is the arrow, 6 is the highlight
				self:addSkinFrame{obj=_G["Browse" .. type .. "Sort"], ft=ftype, nb=true, aso={bd=5}, x2=-2}
			end
			for i = 1, _G.NUM_BROWSE_TO_DISPLAY do
				if _G["BrowseButton" .. i].Orig then break end -- Auctioneer CompactUI loaded
				skinBtn("BrowseButton", i)
			end
			for _, type in pairs{"Name", "MinLevel", "MaxLevel"} do
				self:skinEditBox{obj=_G["Browse" .. type], regs={6, type == "Name" and 7 or nil}, mi=true} -- 6 is text, 7 is icon
				self:moveObject{obj=_G["Browse" .. type], x=type == "MaxLevel" and -6 or -4, y=type ~= "MaxLevel" and 3 or 0}
			end
			self:skinDropDown{obj=_G.BrowseDropDown, x2=109}
			self:skinMoneyFrame{obj=_G.BrowseBidPrice, moveSEB=true}
			_G.BrowseBidButton:DisableDrawLayer("BORDER")
			_G.BrowseBuyoutButton:DisableDrawLayer("BORDER")
			_G.BrowseCloseButton:DisableDrawLayer("BORDER")

			if self.modChkBtns then
				self:skinCheckButton{obj=_G.IsUsableCheckButton}
				self:skinCheckButton{obj=_G.ShowOnPlayerCheckButton}
			end
			if self.modBtnBs then
				self:addButtonBorder{obj=_G.BrowsePrevPageButton, ofs=-2, y1=-3, x2=-3}
				self:addButtonBorder{obj=_G.BrowseNextPageButton, ofs=-2, y1=-3, x2=-3}
			end
			if self.modBtns then
				self:skinStdButton{obj=_G.BrowseSearchButton}
				self:skinStdButton{obj=_G.BrowseCloseButton}
				self:skinStdButton{obj=_G.BrowseBuyoutButton}
				self:skinStdButton{obj=_G.BrowseBidButton}
			end

			self:SecureHookScript(_G.BrowseWowTokenResults, "OnShow", function(this)
				this.Token:DisableDrawLayer("BACKGROUND")
				if self.modBtns then
					self:skinStdButton{obj=this.Buyout}
					self:skinStdButton{obj=_G.StoreButton, x1=14, y1=2, x2=-14, y2=2}
				end
				self:Unhook(this, "OnShow")
			end)
			self:SecureHookScript(_G.WowTokenGameTimeTutorial, "OnShow", function(this)
				this.LeftDisplay.Label:SetTextColor(self.HT:GetRGB())
				this.LeftDisplay.Tutorial1:SetTextColor(self.BT:GetRGB())
				this.RightDisplay.Label:SetTextColor(self.HT:GetRGB())
				this.RightDisplay.Tutorial1:SetTextColor(self.BT:GetRGB())
				self:addSkinFrame{obj=this, ft=ftype, kfs=true, ri=true, ofs=1, y1=2, y2=220}
				self:Unhook(this, "OnShow")
			end)
			self:Unhook(this, "OnShow")

			-- AuctionFrame Bid
			for _, type in pairs{"Quality", "Level", "Duration", "Buyout", "Status", "Bid"} do
				self:keepRegions(_G["Bid" .. type .. "Sort"], {4, 5, 6}) -- N.B. region 4 is the text, 5 is the arrow, 6 is the highlight
				self:addSkinFrame{obj=_G["Bid" .. type .. "Sort"], ft=ftype, aso={bd=5}, x2=-2}
			end
			for i = 1, _G.NUM_BIDS_TO_DISPLAY do
				skinBtn("BidButton", i)
			end
			self:skinSlider{obj=_G.BidScrollFrame.ScrollBar, rt="artwork"}
			self:skinMoneyFrame{obj=_G.BidBidPrice, moveSEB=true}
			_G.BidCloseButton:DisableDrawLayer("BORDER")
			_G.BidBuyoutButton:DisableDrawLayer("BORDER")
			_G.BidBidButton:DisableDrawLayer("BORDER")
			if self.modBtns then
				self:skinStdButton{obj=_G.BidBidButton}
				self:skinStdButton{obj=_G.BidBuyoutButton}
				self:skinStdButton{obj=_G.BidCloseButton}
			end
			self:Unhook(this, "OnShow")

			-- AuctionFrame Auctions
			for _, type in pairs{"Quality", "Duration", "HighBidder", "Bid"} do
				self:keepRegions(_G["Auctions" .. type .. "Sort"], {4, 5, 6}) -- N.B. region 4 is the text, 5 is the arrow, 6 is the highlight
				self:addSkinFrame{obj=_G["Auctions" .. type .. "Sort"], ft=ftype, aso={bd=5}, x2=-2}
			end
			self:skinSlider{obj=_G.AuctionsScrollFrame.ScrollBar, rt="artwork"}
			for i = 1, _G.NUM_AUCTIONS_TO_DISPLAY do
				skinBtn("AuctionsButton", i)
			end
			if not self.modBtnBs then
				self:resizeEmptyTexture(self:getRegion(_G.AuctionsItemButton, 2))
			else
				self:getRegion(_G.AuctionsItemButton, 2):SetAlpha(0) -- texture is changed in blizzard code
				self:addButtonBorder{obj=_G.AuctionsItemButton}
			end
			self:skinEditBox{obj=_G.AuctionsStackSizeEntry, regs={6}, noWidth=true} -- 6 is text
			self:skinEditBox{obj=_G.AuctionsNumStacksEntry, regs={6}, noWidth=true} -- 6 is text
			self:skinDropDown{obj=_G.PriceDropDown}
			self:skinMoneyFrame{obj=_G.StartPrice, moveSEB=true}
			self:skinMoneyFrame{obj=_G.BuyoutPrice, moveSEB=true}
			if self.modBtns then
				self:skinStdButton{obj=_G.AuctionsStackSizeMaxButton}
				self:skinStdButton{obj=_G.AuctionsNumStacksMaxButton}
				self:skinStdButton{obj=_G.AuctionsCreateAuctionButton}
				self:skinStdButton{obj=_G.AuctionsCancelAuctionButton, x2=-1}
				self:skinStdButton{obj=_G.AuctionsCloseButton}
			end
			self:Unhook(this, "OnShow")

			self:SecureHookScript(_G.AuctionProgressFrame, "OnShow", function(this)
				this:DisableDrawLayer("BACKGROUND")
				this:DisableDrawLayer("ARTWORK")
				self:keepFontStrings(_G.AuctionProgressBar)
				self:moveObject{obj=_G.AuctionProgressBar.Text, y=-2}
				self:skinStatusBar{obj=_G.AuctionProgressBar, fi=0}
				self:Unhook(this, "OnShow")
			end)

			self:Unhook(this, "OnShow")
		end)

	end

	self.blizzFrames[ftype].BankFrame = function(self)
		if not self.prdb.BankFrame or self.initialized.BankFrame then return end
		self.initialized.BankFrame = true

		self:SecureHookScript(_G.BankFrame, "OnShow", function(this)

			self:keepFontStrings(_G.BankSlotsFrame)
			self:addSkinFrame{obj=this, ft=ftype, kfs=true, nb=true, x1=10, y1=-11, x2=-33, y2=90}
			if self.modBtns then
				self:skinCloseButton{obj=_G.BankCloseButton}
   			 	self:skinStdButton{obj=_G.BankFramePurchaseButton}
			end
			if self.modBtnBs then
				self:SecureHook("BankFrameItemButton_Update", function(btn)
					if not btn.hasItem then
						btn.sbb:SetBackdropBorderColor(0.498, 0.498, 0.498, 0.5) -- grey border, 50% alpha
					end
				end)
				-- add button borders to bank items
				for i = 1, _G.NUM_BANKGENERIC_SLOTS do
					self:addButtonBorder{obj=_G.BankSlotsFrame["Item" .. i], ibt=true, reParent={_G["BankFrameItem" .. i].IconQuestTexture}, grey=true}
					-- force quality border update
					_G.BankFrameItemButton_Update(_G.BankSlotsFrame["Item" .. i])
				end
				-- add button borders to bags
				for i = 1, _G.NUM_BANKBAGSLOTS do
					self:addButtonBorder{obj=_G.BankSlotsFrame["Bag" .. i], ibt=true}
				end
			end

			self:Unhook(this, "OnShow")
		end)

	end

	self.blizzFrames[ftype].PetStableFrame = function(self)
		if not self.prdb.PetStableFrame or self.initialized.PetStableFrame then return end
		self.initialized.PetStableFrame = true

		self:SecureHookScript(_G.PetStableFrame, "OnShow", function(this)

			self:makeMFRotatable(_G.PetStableModel)
			self:keepFontStrings(_G.PetStableCurrentPet)
			self:keepFontStrings(_G.PetStableStabledPet1)
			_G.PetStableStabledPet2:DisableDrawLayer("BACKGROUND")
			self:addSkinFrame{obj=this, ft=ftype, kfs=true, nb=true, x1=10, y1=-11, x2=-32, y2=71}
			if self.modBtns then
				self:skinCloseButton{obj=_G.PetStableFrameCloseButton}
				self:skinStdButton{obj=_G.PetStablePurchaseButton}
			end
			if self.modBtnBs then
				self:addButtonBorder{obj=_G.PetStableCurrentPet}
				local btn
				for i = 1, _G.NUM_PET_STABLE_SLOTS do
					btn = _G["PetStableStabledPet" .. i]
					self:addButtonBorder{obj=btn}
					self:SecureHook(_G["PetStableStabledPet" .. i .. "Background"], "SetVertexColor", function(this, ...)
						this:GetParent().sbb:SetBackdropBorderColor(...)
					end)
				end
				btn = nil
			end

		end)

	end

	self.blizzLoDFrames[ftype].TrainerUI = function(self)
		if not self.prdb.TrainerUI or self.initialized.TrainerUI then return end
		self.initialized.TrainerUI = true

		self:SecureHookScript(_G.ClassTrainerFrame, "OnShow", function(this)
			self:skinDropDown{obj=_G.ClassTrainerFrameFilterDropDown}
			self:removeMagicBtnTex(_G.ClassTrainerTrainButton)
			if self.modBtns then
				 self:skinStdButton{obj=_G.ClassTrainerTrainButton}
				 self:skinStdButton{obj=_G.ClassTrainerCancelButton}
			end
			self:keepFontStrings(_G.ClassTrainerExpandButtonFrame)
			if self.modBtns then
				self:skinExpandButton{obj=_G.ClassTrainerCollapseAllButton, onSB=true}
				for i = 1, _G.CLASS_TRAINER_SKILLS_DISPLAYED do
					self:skinExpandButton{obj=_G["ClassTrainerSkill" .. i], onSB=true}
				end
				self:SecureHook("ClassTrainerFrame_Update", function()
					for i = 1, _G.CLASS_TRAINER_SKILLS_DISPLAYED do
						self:checkTex{obj=_G["ClassTrainerSkill" .. i]}
					end
				end)
			end
			_G.ClassTrainerSkillIcon:DisableDrawLayer("BACKGROUND")
			if self.modBtnBs then
				self:addButtonBorder{obj=_G.ClassTrainerSkillIcon}
			end
			self:skinSlider{obj=_G.ClassTrainerListScrollFrame.ScrollBar, rt="background"}
			self:skinSlider{obj=_G.ClassTrainerDetailScrollFrame.ScrollBar, rt="background"}
			self:addSkinFrame{obj=this, ft=ftype, kfs=true, x1=10, y1=-11, x2=-31.5, y2=70}

			self:Unhook(this, "OnShow")
		end)

	end

	ftype = "p"
	self.blizzFrames[ftype].CharacterFrames = function(self)
		if not self.prdb.CharacterFrames or self.initialized.CharacterFrames then return end
		self.initialized.CharacterFrames = true

		self:skinTabs{obj=_G.CharacterFrame, lod=true}
		self:addSkinFrame{obj=_G.CharacterFrame, ft=ftype, kfs=true, x1=10, y1=-12, x2=-31, y2=71}

		self:keepFontStrings(_G.PaperDollFrame)
		self:makeMFRotatable(_G.CharacterModelFrame)
		_G.CharacterAttributesFrame:DisableDrawLayer("BACKGROUND")
		if self.modBtnBs then
			for i = 1, 5 do
				self:addButtonBorder{obj=_G["MagicResFrame" .. i], ofs=0, x1=1, y2=-2}
			end
			self:SecureHook("PaperDollItemSlotButton_Update", function(btn)
				local icon = btn.Icon or btn.icon or _G[btn:GetName() .. "IconTexture"]
				if not btn.hasItem then
					btn.sbb:SetBackdropBorderColor(0.498, 0.498, 0.498, 0.85) -- grey border, 85% alpha
					icon:SetTexture(nil)
				else
					btn.sbb:SetBackdropBorderColor(icon:GetVertexColor())
				end
			end)
		end
		for _, btn in pairs{_G.PaperDollItemsFrame:GetChildren()} do
			btn:DisableDrawLayer("BACKGROUND")
			if btn ~= _G.CharacterAmmoSlot then
				if self.modBtnBs then
					self:addButtonBorder{obj=btn, ibt=true, reParent={btn.ignoreTexture}, grey=true}
					-- force quality border update
					_G.PaperDollItemSlotButton_Update(btn)
				end
			else
				btn:DisableDrawLayer("OVERLAY")
				btn:GetNormalTexture():SetTexture(nil)
				btn:GetPushedTexture():SetTexture(nil)
				if self.modBtnBs then
					self:addButtonBorder{obj=btn, reParent={btn.Count, self:getRegion(btn, 4)}, grey=true}
				end
			end
		end

		self:SecureHookScript(_G.ReputationFrame, "OnShow", function(this)
			self:keepFontStrings(this)
			for i = 1, _G.NUM_FACTIONS_DISPLAYED do
				if self.modBtns then
					self:skinExpandButton{obj=_G["ReputationHeader" .. i], onSB=true}
				end
				self:removeRegions(_G["ReputationBar" .. i], {1, 2})
				self:skinStatusBar{obj=_G["ReputationBar" .. i], fi=0}
			end
			if self.modBtns then
				self:skinCloseButton{obj=_G.ReputationDetailCloseButton}
			end
			if self.modChkBtns then
				self:skinCheckButton{obj=_G.ReputationDetailAtWarCheckBox}
				self:skinCheckButton{obj=_G.ReputationDetailInactiveCheckBox}
				self:skinCheckButton{obj=_G.ReputationDetailMainScreenCheckBox}
			end
			self:addSkinFrame{obj=_G.ReputationDetailFrame, ft=ftype, kfs=true, x1=6, y1=-6, x2=-6, y2=6}

			self:Unhook(this, "OnShow")
		end)

		self:SecureHookScript(_G.PetPaperDollFrame, "OnShow", function(this)
			self:keepFontStrings(this)
			self:keepFontStrings(_G.PetPaperDollFrameExpBar)
			self:skinStatusBar{obj=_G.PetPaperDollFrameExpBar, fi=0}
			self:makeMFRotatable(_G.PetModelFrame)
			-- TODO: PetPaperDollPetInfo (a.k.a. UI-PetHappiness)
			_G.PetAttributesFrame:DisableDrawLayer("BACKGROUND")
			if self.modBtnBs then
				for i = 1, 5 do
					self:addButtonBorder{obj=_G["PetMagicResFrame" .. i], ofs=0, x1=1, y2=-2}
				end
				self:skinStdButton{obj=_G.PetPaperDollCloseButton}
			end

			self:Unhook(this, "OnShow")
		end)

		self:SecureHookScript(_G.SkillFrame, "OnShow", function(this)
			self:keepFontStrings(this)
			_G.SkillFrameExpandButtonFrame:DisableDrawLayer("BACKGROUND")
			if self.modBtns then
				self:skinExpandButton{obj=_G.SkillFrameCollapseAllButton, onSB=true}
			end
			for i = 1, _G.SKILLS_TO_DISPLAY do
				if self.modBtns then
					 self:skinExpandButton{obj=_G["SkillTypeLabel"  .. i], onSB=true}
				end
				_G["SkillRankFrame"  .. i .. "Border"]:GetNormalTexture():SetTexture(nil)
				self:skinStatusBar{obj=_G["SkillRankFrame"  .. i], fi=0, bgTex=_G["SkillRankFrame"  .. i .. "Background"], otherTex={_G["SkillRankFrame"  .. i .. "FillBar"]}}
			end
			self:skinSlider{obj=_G.SkillListScrollFrame.ScrollBar, rt="artwork"}
			self:skinSlider{obj=_G.SkillDetailScrollFrame.ScrollBar, rt="artwork"}
			if self.modBtns then
				self:skinStdButton{obj=_G.SkillFrameCancelButton}
			end

			self:Unhook(this, "OnShow")
		end)

		self:SecureHookScript(_G.HonorFrame, "OnShow", function(this)
			self:keepFontStrings(this)
			self:skinStatusBar{obj=_G.HonorFrameProgressBar, fi=0}

			self:Unhook(this, "OnShow")
		end)

	end

	self.blizzFrames[ftype].ContainerFrames = function(self)
		if not self.prdb.ContainerFrames.skin or self.initialized.ContainerFrames then return end
		self.initialized.ContainerFrames = true

		local objName
		local function skinBag(frame, id)

			frame.PortraitButton.Highlight:SetTexture(nil)
			aObj:addSkinFrame{obj=frame, ft=ftype, kfs=true, x1=8, y1=-4, x2=-3}
			-- resize and move the bag name to make it more readable
			objName = frame:GetName()
			_G[objName .. "Name"]:SetWidth(137)
			aObj:moveObject{obj=_G[objName .. "Name"], x=-17}

			if aObj.modBtnBs then
				-- skin the item buttons
				local bo
				for i = 1, _G.MAX_CONTAINER_ITEMS do
					bo = _G[objName .. "Item" .. i]
					aObj:addButtonBorder{obj=bo, ibt=true, reParent={_G[objName .. "Item" .. i .. "IconQuestTexture"], bo.JunkIcon, bo.UpgradeIcon, bo.flash, bo.NewItemTexture, bo.BattlepayItemTexture}}
				end
				bo = nil
				-- update Button quality borders
				_G.ContainerFrame_Update(frame)
			end

			objName = nil

		end

		self:SecureHook("ContainerFrame_GenerateFrame", function(frame, size, id)
			-- skin the frame if required
			if not frame.sf then
				skinBag(frame, id)
			end
		end)

		self:SecureHookScript(_G.BagHelpBox, "OnShow", function(this)
			self:skinCloseButton{obj=this.CloseButton, noSkin=true}
			self:Unhook(this, "OnShow")
		end)

	end

	self.blizzLoDFrames[ftype].CraftUI = function(self)
		if not self.prdb.CraftUI or self.initialized.CraftUI then return end
		self.initialized.CraftUI = true

		self:SecureHookScript(_G.CraftFrame, "OnShow", function(this)

			self:skinStatusBar{obj=_G.CraftRankFrame, fi=0, bgTex=_G.CraftRankFrameBackground}
			self:keepFontStrings(_G.CraftExpandButtonFrame)
			self:skinSlider{obj=_G.CraftListScrollFrameScrollBar, rt="background"}
			self:skinSlider{obj=_G.CraftDetailScrollFrameScrollBar, rt="background"}
			self:removeRegions(_G.CraftDetailScrollChildFrame, {4, 5})
			self:addSkinFrame{obj=this, ft=ftype, kfs=true, nb=true, x1=10, y1=-11, x2=-32, y2=71}
			if self.modBtns then
				self:skinExpandButton{obj=_G.CraftCollapseAllButton, onSB=true}
				self:skinCloseButton{obj=_G.CraftFrameCloseButton}
				self:skinStdButton{obj=_G.CraftCreateButton}
				self:skinStdButton{obj=_G.CraftCancelButton}
			end
			if self.modBtnBs then
				self:addButtonBorder{obj=_G.CraftIcon}
			end

			self:Unhook(this, "OnShow")
		end)

	end

	self.blizzFrames[ftype].FriendsFrame = function(self)
		if not self.prdb.FriendsFrame or self.initialized.FriendsFrame then return end
		self.initialized.FriendsFrame = true

		local function addTabFrame(frame)
			aObj:addSkinFrame{obj=frame, ft=ftype, kfs=true, nb=true, ofs=0, y1=-81, y2=-2, aso={bd=10, ng=true}}
		end

		self:SecureHookScript(_G.FriendsFrame, "OnShow", function(this)
			self:skinTabs{obj=this, lod=true}
			self:addSkinFrame{obj=this, ft=ftype, kfs=true, ri=true, y2=-5}
			self:moveObject{obj=this.CloseButton, x=2}

			self:skinDropDown{obj=_G.FriendsDropDown}
			self:skinDropDown{obj=_G.TravelPassDropDown}

			self:SecureHookScript(_G.FriendsTabHeader, "OnShow", function(this)
				_G.FriendsFrameBattlenetFrame:DisableDrawLayer("BACKGROUND")
				if self.modBtnBs then
					self:addButtonBorder{obj=_G.FriendsFrameBattlenetFrame.BroadcastButton, ofs=-2}
				end
				self:addSkinFrame{obj=_G.FriendsFrameBattlenetFrame.BroadcastFrame.ScrollFrame, ft=ftype, kfs=true, nb=true, ofs=4}
				if self.modBtns then
					self:skinStdButton{obj=_G.FriendsFrameBattlenetFrame.BroadcastFrame.ScrollFrame.UpdateButton}
					self:skinStdButton{obj=_G.FriendsFrameBattlenetFrame.BroadcastFrame.ScrollFrame.CancelButton}
				end
				_G.FriendsFrameBattlenetFrame.BroadcastFrame.ScrollFrame.EditBox.PromptText:SetTextColor(self.BT:GetRGB())
				_G.FriendsFrameBattlenetFrame.BroadcastFrame:DisableDrawLayer("BACKGROUND")
				self:addSkinFrame{obj=_G.FriendsFrameBattlenetFrame.BroadcastFrame, ft=ftype, ofs=-10}
				self:addSkinFrame{obj=_G.FriendsFrameBattlenetFrame.UnavailableInfoFrame, ft=ftype}
				self:skinDropDown{obj=_G.FriendsFrameStatusDropDown}
				_G.FriendsFrameStatusDropDownStatus:SetAlpha(1) -- display status icon
				self:skinEditBox{obj=_G.FriendsFrameBroadcastInput, regs={6, 7}, mi=true, noWidth=true, noHeight=true, noMove=true} -- 6 is text, 7 is icon
				_G.FriendsFrameBroadcastInputFill:SetTextColor(self.BT:GetRGB())
				_G.PanelTemplates_SetNumTabs(this, 2) -- adjust for Friends & Ignore
				self:skinTabs{obj=this, up=true, lod=true, x1=0, y1=-5, x2=0, y2=-5}
				if self.modBtnBs then
					self:addButtonBorder{obj=_G.FriendsTabHeaderRecruitAFriendButton}
					self:addButtonBorder{obj=_G.FriendsTabHeaderSoRButton}
				end
				_G.RaiseFrameLevel(this)
				self:Unhook(this, "OnShow")
			end)
			self:checkShown(_G.FriendsTabHeader)

			self:SecureHookScript(_G.FriendsListFrame, "OnShow", function(this)
				if self.modBtns then
					self:skinStdButton{obj=_G.FriendsFrameAddFriendButton, x1=1}
					self:skinStdButton{obj=_G.FriendsFrameSendMessageButton}
					self:skinStdButton{obj=self:getChild(this.RIDWarning, 1)} -- unnamed parent frame
				end
				if self.modBtnBs then
					self:addButtonBorder{obj=_G.FriendsFrameFriendsScrollFrame.PendingInvitesHeaderButton}
				end
				_G.FriendsFrameFriendsScrollFrame.PendingInvitesHeaderButton.BG:SetTexture(nil)
				if self.modBtns then
					for invite in _G.FriendsFrameFriendsScrollFrame.invitePool:EnumerateActive() do
						self:skinStdButton{obj=invite.DeclineButton}
						self:skinStdButton{obj=invite.AcceptButton}
					end
				end
				self:skinSlider{obj=_G.FriendsFrameFriendsScrollFrame.scrollBar, rt="background"}
				-- adjust width of FFFSF so it looks right (too thin by default)
				_G.FriendsFrameFriendsScrollFrame.scrollBar:ClearAllPoints()
				_G.FriendsFrameFriendsScrollFrame.scrollBar:SetPoint("TOPRIGHT", "FriendsFrame", "TOPRIGHT", -8, -101)
				_G.FriendsFrameFriendsScrollFrame.scrollBar:SetPoint("BOTTOMLEFT", "FriendsFrame", "BOTTOMRIGHT", -24, 40)
				local btn
				for i = 1, _G.FRIENDS_FRIENDS_TO_DISPLAY do
					btn = _G["FriendsFrameFriendsScrollFrameButton" .. i]
					btn.background:SetAlpha(0)
					if self.modBtnBs then
						self:addButtonBorder{obj=btn, relTo=btn.gameIcon, ofs=0}
						self:SecureHook(btn.gameIcon, "Show", function(this)
							this:GetParent().sbb:Show()
						end)
						self:SecureHook(btn.gameIcon, "Hide", function(this)
							this:GetParent().sbb:Hide()
						end)
						self:SecureHook(btn.gameIcon, "SetShown", function(this, show)
							this:GetParent().sbb:SetShown(this, show)
						end)
						btn.sbb:SetShown(btn.gameIcon:IsShown())
						self:addButtonBorder{obj=btn.travelPassButton, ofs=0, y1=3, y2=-2}
						self:SecureHook(btn.travelPassButton, "Enable", function(this)
							this.sbb:SetBackdropBorderColor(self.bbClr:GetRGBA())
						end)
						self:SecureHook(btn.travelPassButton, "Disable", function(this)
							this.sbb:SetBackdropBorderColor(0.5, 0.5, 0.5)
						end)
						if not btn.travelPassButton:IsEnabled() then btn.travelPassButton.sbb:SetBackdropBorderColor(0.5, 0.5, 0.5, 1) end
						self:addButtonBorder{obj=btn.summonButton}
						self:SecureHook(btn.summonButton, "Enable", function(this)
							this.sbb:SetBackdropBorderColor(self.bbClr:GetRGBA())
						end)
						self:SecureHook(btn.summonButton, "Disable", function(this)
							this.sbb:SetBackdropBorderColor(0.5, 0.5, 0.5, 1)
						end)
						if not btn.summonButton:IsEnabled() then btn.summonButton.sbb:SetBackdropBorderColor(0.5, 0.5, 0.5) end
					end
				end
				btn = nil
				addTabFrame(this)
				self:Unhook(this, "OnShow")
			end)
			self:checkShown(_G.FriendsListFrame)

			self:SecureHookScript(_G.IgnoreListFrame, "OnShow", function(this)
				this:DisableDrawLayer("BACKGROUND")
				if self.modBtns then
					self:skinStdButton{obj=_G.FriendsFrameIgnorePlayerButton, x1=1}
					self:skinStdButton{obj=_G.FriendsFrameUnsquelchButton}
				end
				self:skinSlider{obj=_G.FriendsFrameIgnoreScrollFrame.ScrollBar}
				addTabFrame(this)
				self:Unhook(this, "OnShow")
			end)

			self:SecureHookScript(_G.WhoFrame, "OnShow", function(this)
				self:removeInset(_G.WhoFrameListInset)
				self:skinColHeads("WhoFrameColumnHeader")
				self:skinDropDown{obj=_G.WhoFrameDropDown}
				-- remove col head 2 as it is really a dropdown
				_G.WhoFrameColumnHeader2.sf.tfade:SetTexture(nil)
				_G.WhoFrameColumnHeader2.sf:SetBackdrop(nil)
				_G.WhoFrameColumnHeader2.sf:Hide()
				self:moveObject{obj=_G.WhoFrameColumnHeader4, x=4}
				if self.modBtns then
					self:skinStdButton{obj=_G.WhoFrameGroupInviteButton}
					self:skinStdButton{obj=_G.WhoFrameAddFriendButton}
					self:skinStdButton{obj=_G.WhoFrameWhoButton}
				end
				self:removeInset(_G.WhoFrameEditBoxInset)
				self:skinEditBox{obj=_G.WhoFrameEditBox}--, move=true}
				_G.WhoFrameEditBox:SetWidth(_G.WhoFrameEditBox:GetWidth() + 24)
				self:moveObject{obj=_G.WhoFrameEditBox, x=11, y=6}
				self:skinSlider{obj=_G.WhoListScrollFrame.ScrollBar, rt="background"}
				self:Unhook(this, "OnShow")
			end)

			-- tooltip
			_G.C_Timer.After(0.1, function()
				self:add2Table(self.ttList, _G.FriendsTooltip)
			end)

			self:Unhook(this, "OnShow")
		end)

		self:SecureHookScript(_G.AddFriendFrame, "OnShow", function(this)
			if self.modBtns then
				self:skinStdButton{obj=_G.AddFriendInfoFrameContinueButton}
				self:skinStdButton{obj=_G.AddFriendEntryFrameAcceptButton}
				self:skinStdButton{obj=_G.AddFriendEntryFrameCancelButton}
			end
			self:skinEditBox{obj=_G.AddFriendNameEditBox, regs={6}} -- 6 is text
			self:skinSlider{obj=_G.AddFriendNoteFrameScrollFrame.ScrollBar}
			self:addSkinFrame{obj=_G.AddFriendNoteFrame, ft=ftype, kfs=true}
			self:addSkinFrame{obj=this, ft=ftype, kfs=true}
			self:Unhook(this, "OnShow")
		end)

		self:SecureHookScript(_G.FriendsFriendsFrame, "OnShow", function(this)
			self:skinDropDown{obj=_G.FriendsFriendsFrameDropDown}
			self:addSkinFrame{obj=_G.FriendsFriendsList, ft=ftype}
			self:skinSlider{obj=_G.FriendsFriendsScrollFrame.ScrollBar}
			if self.modBtns then
				self:skinStdButton{obj=_G.FriendsFriendsSendRequestButton}
				self:skinStdButton{obj=_G.FriendsFriendsCloseButton}
			end
			self:addSkinFrame{obj=this, ft=ftype}
			self:Unhook(this, "OnShow")
		end)

		self:SecureHookScript(_G.BattleTagInviteFrame, "OnShow", function(this)
			if self.modBtns then
				self:skinStdButton{obj=self:getChild(this, 1)} -- Send Request
				self:skinStdButton{obj=self:getChild(this, 2)} -- Cancel
			end
			self:addSkinFrame{obj=this, ft=ftype}
			self:Unhook(this, "OnShow")
		end)

		self:SecureHookScript(_G.RecruitAFriendFrame, "OnShow", function(this)
			self:skinEditBox{obj=_G.RecruitAFriendNameEditBox, regs={6}} -- 6 is text
			_G.RecruitAFriendNameEditBox.Fill:SetTextColor(self.BT:GetRGB())
			self:addSkinFrame{obj=_G.RecruitAFriendNoteFrame, ft=ftype, kfs=true}
			_G.RecruitAFriendNoteEditBox.Fill:SetTextColor(self.BT:GetRGB())
			self:skinStdButton{obj=_G.RecruitAFriendFrame.SendButton}
			self:addSkinFrame{obj=this, ft=ftype, kfs=true, ofs=-6, y1=-7}
			-- RecruitAFriendSentFrame
			self:skinStdButton{obj=_G.RecruitAFriendSentFrame.OKButton}
			self:addSkinFrame{obj=_G.RecruitAFriendSentFrame, ft=ftype, ofs=-7, y2=4}
			self:Unhook(this, "OnShow")
		end)

		self:SecureHookScript(_G.ChannelFrame, "OnShow", function(this)
			self:removeInset(this.LeftInset)
			self:removeInset(this.RightInset)
			if self.modBtns then
				self:skinStdButton{obj=this.NewButton}
				self:skinStdButton{obj=this.SettingsButton}
				self:skinCloseButton{obj=this.Tutorial.CloseButton, noSkin=true}
			end
			self:skinSlider{obj=this.ChannelList.ScrollBar, wdth=-4}
			self:skinSlider{obj=this.ChannelRoster.ScrollFrame.scrollBar, wdth=-4}
			self:addSkinFrame{obj=this, ft=ftype, kfs=true, ri=true, x1=-5, y2=-1}
			-- Create Channel Popup
			self:skinEditBox{obj=_G.CreateChannelPopup.Name, regs={6}} -- 6 is text
			self:skinEditBox{obj=_G.CreateChannelPopup.Password, regs={6}} -- 6 is text
			if self.modChkBtns then
				self:skinCheckButton{obj=_G.CreateChannelPopup.UseVoiceChat}
			end
			if self.modBtns then
				self:skinStdButton{obj=_G.CreateChannelPopup.OKButton}
				self:skinStdButton{obj=_G.CreateChannelPopup.CancelButton}
			end
			self:addSkinFrame{obj=_G.CreateChannelPopup, ft=ftype, kfs=true}
			self:Unhook(this, "OnShow")
		end)

		self:SecureHook(_G.ChannelFrame.ChannelList, "Update", function(this)
			for header in this.headerButtonPool:EnumerateActive() do
				header:GetNormalTexture():SetTexture(nil)
			end
			for textChannel in this.textChannelButtonPool:EnumerateActive() do
			end
			for voiceChannel in this.voiceChannelButtonPool:EnumerateActive() do
			end
			for communityChannel in this.communityChannelButtonPool:EnumerateActive() do
			end
		end)

		self:SecureHookScript(_G.VoiceChatPromptActivateChannel, "OnShow", function(this)
			self:skinCloseButton{obj=this.CloseButton, font=self.fontSBX, aso={bd=5, bba=0}, onSB=true, storeOnParent=true}
			self:skinStdButton{obj=this.AcceptButton}
			self:addSkinFrame{obj=this, ft=ftype, nb=true}
			self:hookSocialToastFuncs(this)
			self:Unhook(this, "OnShow")
		end)

		self:SecureHookScript(_G.VoiceChatChannelActivatedNotification, "OnShow", function(this)
			self:skinCloseButton{obj=this.CloseButton, font=self.fontSBX, aso={bd=5, bba=0}, onSB=true, storeOnParent=true}
			self:addSkinFrame{obj=this, ft=ftype, nb=true}
			self:hookSocialToastFuncs(this)
			self:Unhook(this, "OnShow")
		end)

	end

	self.blizzLoDFrames[ftype].TradeSkillUI = function(self)
		if not self.prdb.TradeSkillUI or self.initialized.TradeSkillUI then return end
		self.initialized.TradeSkillUI = true

		self:SecureHookScript(_G.TradeSkillFrame, "OnShow", function(this)

			self:skinStatusBar{obj=_G.TradeSkillRankFrame, fi=0, bgTex=_G.TradeSkillRankFrameBackground}
			_G.TradeSkillRankFrameBorder:GetNormalTexture():SetTexture(nil)
			self:keepFontStrings(_G.TradeSkillExpandButtonFrame)
			self:skinDropDown{obj=_G.TradeSkillInvSlotDropDown}
			self:skinDropDown{obj=_G.TradeSkillSubClassDropDown}
			self:skinSlider{obj=_G.TradeSkillListScrollFrame.ScrollBar}
			self:skinSlider{obj=_G.TradeSkillDetailScrollFrame.ScrollBar}
			self:keepFontStrings(_G.TradeSkillDetailScrollChildFrame)
			local btnName
			for i = 1, _G.MAX_TRADE_SKILL_REAGENTS do
				btnName = "TradeSkillReagent" .. i
				_G[btnName .. "NameFrame"]:SetTexture(nil)
				if self.modBtns then
					 self:addButtonBorder{obj=_G[btnName], libt=true}
				end
			end
			btnName = nil
			self:skinEditBox{obj=_G.TradeSkillInputBox, regs={6}, x=-6} -- 6 is text
			self:addSkinFrame{obj=_G.TradeSkillFrame, ft=ftype, kfs=true, nb=true, x1=10, y1=-11, x2=-32, y2=70}
			if self.modBtns then
				self:skinExpandButton{obj=_G.TradeSkillCollapseAllButton, onSB=true}
				for i = 1, _G.TRADE_SKILLS_DISPLAYED do
					self:skinExpandButton{obj=_G["TradeSkillSkill" .. i], onSB=true}
				end
				self:skinCloseButton{obj=_G.TradeSkillFrameCloseButton}
				self:skinStdButton{obj=_G.TradeSkillCreateButton}
				self:skinStdButton{obj=_G.TradeSkillCancelButton}
				self:skinStdButton{obj=_G.TradeSkillCreateAllButton}
			end
			if self.modBtnBs then
				self:addButtonBorder{obj=_G.TradeSkillSkillIcon}
				self:addButtonBorder{obj=_G.TradeSkillDecrementButton, ofs=0}
				self:addButtonBorder{obj=_G.TradeSkillIncrementButton, ofs=0}
			end

			self:Unhook(this, "OnShow")

		end)

	end

	ftype = "u"
	self.blizzFrames[ftype].BattlefieldFrame = function(self)
		if not self.prdb.BattlefieldFrame or self.initialized.BattlefieldFrame then return end
		self.initialized.BattlefieldFrame = true

		self:SecureHookScript(_G.BattlefieldFrame, "OnShow", function(this)

			self:skinSlider{obj=_G.BattlefieldListScrollFrame.ScroolBar}--, rt="artwork", wdth=-4, size=3, hgt=-10}
			self:addSkinFrame{obj=this, ft=ftype, kfs=true, nb=true}
			if self.modBtns then
				self:skinCloseButton{obj=_G.BattlefieldFrameCloseButton}
				self:skinStdButton{obj=_G.BattlefieldFrameCancelButton}
				self:skinStdButton{obj=_G.BattlefieldFrameJoinButton}
				self:skinStdButton{obj=_G.BattlefieldFrameGroupJoinButton}
			end

			self:Unhook(this, "OnShow")
		end)

	end

	self.blizzFrames[ftype].ChatButtons = function(self)
		if not self.prdb.ChatButtons or self.initialized.ChatButtons then return end
		self.initialized.ChatButtons = true

		-- QuickJoinToastButton & frames (attached to ChatFrame)
		if self.modBtnBs then
			for i = 1, _G.NUM_CHAT_WINDOWS do
				self:addButtonBorder{obj=_G["ChatFrame" .. i].buttonFrame.minimizeButton, ofs=-2}
				self:addButtonBorder{obj=_G["ChatFrame" .. i].ScrollToBottomButton, ofs=-1, reParent={_G["ChatFrame" .. i].ScrollToBottomButton.Flash}}
				self:addButtonBorder{obj=_G["ChatFrame" .. i].buttonFrame.bottomButton, ofs=-2}
				self:addButtonBorder{obj=_G["ChatFrame" .. i].buttonFrame.downButton, ofs=-2}
				self:addButtonBorder{obj=_G["ChatFrame" .. i].buttonFrame.upButton, ofs=-2}
			end
			self:addButtonBorder{obj=_G.ChatFrameChannelButton, ofs=0}
			self:addButtonBorder{obj=_G.ChatFrameMenuButton, ofs=-2}
		end

	end

	-- ChatEditBox
	self.cebRgns1 = {1, 2, 6, 7} -- 1, 6, 7 are font strings, 2 is cursor texture
	self.cebRgns2 = {6, 7}

	self.blizzFrames[ftype].MainMenuBar = function(self)
		if self.initialized.MainMenuBar then return end
		self.initialized.MainMenuBar = true

		if self.prdb.MainMenuBar.skin then

			_G.MainMenuExpBar:DisableDrawLayer("OVERLAY")
			self:moveObject{obj=_G.MainMenuExpBar, y=2}
			self:skinStatusBar{obj=_G.MainMenuExpBar, fi=0, bgTex=self:getRegion(_G.MainMenuExpBar, 6), otherTex={_G.ExhaustionLevelFillBar}}
			-- MainMenuBarMaxLevelBar
			_G.MainMenuBarArtFrame:DisableDrawLayer("BACKGROUND")
			_G.MainMenuBarLeftEndCap:SetTexture(nil)
			_G.MainMenuBarRightEndCap:SetTexture(nil)
			-- MainMenuBarPerformanceBarFrameButton

			_G.ExhaustionTick:GetNormalTexture():SetTexture(nil)
			_G.ExhaustionTick:GetHighlightTexture():SetTexture(nil)

			-- StanceBar Frame
			self:keepFontStrings(_G.StanceBarFrame)
			-- Pet Action Bar Frame
			self:keepFontStrings(_G.PetActionBarFrame)

			self:addSkinFrame{obj=_G.MainMenuBar, ft=ftype, kfs=true, nb=true, bg=true, noBdr=true, ofs=4, y1=-7}

			if self.modBtnBs then
				for i = 1, _G.NUM_STANCE_SLOTS do
					self:addButtonBorder{obj=_G["StanceButton" .. i], abt=true, sec=true}
				end
				for i = 1, _G.NUM_PET_ACTION_SLOTS do
					self:addButtonBorder{obj=_G["PetActionButton" .. i], abt=true, sec=true, reParent={_G["PetActionButton" .. i .. "AutoCastable"], _G["PetActionButton" .. i .. "SpellHighlightTexture"]}, ofs=3}
					_G["PetActionButton" .. i .. "Shine"]:SetParent(_G["PetActionButton" .. i].sbb)
				end
				-- Action Buttons
				for i = 1, _G.NUM_ACTIONBAR_BUTTONS do
					_G["ActionButton" .. i].FlyoutBorder:SetTexture(nil)
					_G["ActionButton" .. i].FlyoutBorderShadow:SetTexture(nil)
					self:addButtonBorder{obj=_G["ActionButton" .. i], abt=true, seca=true}
				end
				-- ActionBar buttons
				self:addButtonBorder{obj=_G.ActionBarUpButton, ofs=-4}
				self:addButtonBorder{obj=_G.ActionBarDownButton, ofs=-4}

				-- Micro buttons
				local mBut
				for i = 1, #_G.MICRO_BUTTONS do
					mBut = _G[_G.MICRO_BUTTONS[i]]
					self:addButtonBorder{obj=mBut, ofs=0, y1=-20, reParent=mBut == "MainMenuMicroButton" and {mBut.Flash, _G.MainMenuBarDownload} or {mBut.Flash}}
				end
				mBut = nil

				-- skin bag buttons
				self:addButtonBorder{obj=_G.MainMenuBarBackpackButton, ibt=true}
				self:addButtonBorder{obj=_G.CharacterBag0Slot, ibt=true}
				self:addButtonBorder{obj=_G.CharacterBag1Slot, ibt=true}
				self:addButtonBorder{obj=_G.CharacterBag2Slot, ibt=true}
				self:addButtonBorder{obj=_G.CharacterBag3Slot, ibt=true}

				-- MultiBar Buttons
				for _, type in pairs{"BottomLeft", "BottomRight", "Right", "Left"} do
					local btn
					for i = 1, _G.NUM_MULTIBAR_BUTTONS do
						btn = _G["MultiBar" .. type .. "Button" .. i]
						btn.FlyoutBorder:SetTexture(nil)
						btn.FlyoutBorderShadow:SetTexture(nil)
						btn.Border:SetAlpha(0) -- texture changed in blizzard code
						if not btn.noGrid then
							_G[btn:GetName() .. "FloatingBG"]:SetAlpha(0)
						end
						self:addButtonBorder{obj=btn, abt=true, seca=true}
					end
					btn = nil
				end

			end

		end

		-- these are done here as other AddOns may require them to be skinned
		if self.modBtnBs then
			self:addButtonBorder{obj=_G.MainMenuBarVehicleLeaveButton}
		end

	end

	self.blizzFrames[ftype].QuestLog = function(self)
		if not self.prdb.QuestLog or self.initialized.QuestLog then return end
		self.initialized.QuestLog = true

		self:SecureHookScript(_G.QuestLogFrame, "OnShow", function(this)

			_G.QuestLogCollapseAllButton:DisableDrawLayer("BACKGROUND")
			self:keepFontStrings(_G.EmptyQuestLogFrame)
			if self.modBtns then
				self:skinExpandButton{obj=_G.QuestLogCollapseAllButton, onSB=true}
				for i = 1, _G.QUESTS_DISPLAYED do
					self:skinExpandButton{obj=_G["QuestLogTitle" .. i], onSB=true}
					self:checkTex{obj=_G["QuestLogTitle" .. i]}
				end
				self:SecureHook("QuestLog_Update", function(this)
					for i = 1, _G.QUESTS_DISPLAYED do
						self:checkTex{obj=_G["QuestLogTitle" .. i]}
					end
				end)
			end
			-- TODO: _G["QuestLogTitle" .. i .. "Check"] texture

			self:skinSlider{obj=_G.QuestLogListScrollFrame.ScrollBar}
			self:skinSlider{obj=_G.QuestLogDetailScrollFrame.ScrollBar}

			_G.QuestLogQuestTitle:SetTextColor(self.HT:GetRGB())
			_G.QuestLogObjectivesText:SetTextColor(self.BT:GetRGB())
			_G.QuestLogTimerText:SetTextColor(self.BT:GetRGB())
			for i = 1, _G.MAX_OBJECTIVES do
				_G["QuestLogObjective" .. i]:SetTextColor(self.BT:GetRGB())
			end
			_G.QuestLogRequiredMoneyText:SetTextColor(self.BT:GetRGB())
			_G.QuestLogDescriptionTitle:SetTextColor(self.HT:GetRGB())
			_G.QuestLogQuestDescription:SetTextColor(self.BT:GetRGB())
			_G.QuestLogRewardTitleText:SetTextColor(self.HT:GetRGB())
			_G.QuestLogItemChooseText:SetTextColor(self.BT:GetRGB())
			_G.QuestLogItemReceiveText:SetTextColor(self.BT:GetRGB())
			_G.QuestLogSpellLearnText:SetTextColor(self.BT:GetRGB())

			self:SecureHook("QuestLog_UpdateQuestDetails", function(...)
				for i = 1, _G.MAX_OBJECTIVES do
					_G["QuestLogObjective" .. i]:SetTextColor(self.BT:GetRGB())
				end
				_G.QuestLogRequiredMoneyText:SetTextColor(self.BT:GetRGB())
				_G.QuestLogRewardTitleText:SetTextColor(self.HT:GetRGB())
				_G.QuestLogItemChooseText:SetTextColor(self.BT:GetRGB())
				_G.QuestLogItemReceiveText:SetTextColor(self.BT:GetRGB())
			end)

			local btnName
			for i = 1, _G.MAX_NUM_ITEMS do
				btnName = "QuestLogItem" .. i
				_G[btnName .. "NameFrame"]:SetTexture(nil)
				if self.modBtns then
					 self:addButtonBorder{obj=_G[btnName], libt=true}
				end
			end
			btnName = nil

			self:addSkinFrame{obj=this, ft=ftype, kfs=true, nb=true, x1=10, y1=-11, x2=-33, y2=50}
			if self.modBtns then
				self:skinCloseButton{obj=_G.QuestLogFrameCloseButton}
				self:skinStdButton{obj=_G.QuestLogFrameAbandonButton}
				self:skinStdButton{obj=_G.QuestFrameExitButton}
				self:skinStdButton{obj=_G.QuestFramePushQuestButton, x1=0}
			end

			self:Unhook(this, "OnShow")
		end)

	end

	self.blizzFrames[ftype].QuestTimer = function(self)
		if not self.prdb.QuestTimer or self.initialized.QuestTimer then return end
		self.initialized.QuestTimer = true

		self:addSkinFrame{obj=_G.QuestTimerFrame, ft=ftype, kfs=true, nb=true, ofs=4}

	end

	self.blizzLoDFrames[ftype].TalentUI = function(self)
		if not self.prdb.TalentUI or self.initialized.TalentUI then return end
		self.initialized.Talent = true

		self:SecureHookScript(_G.TalentFrame, "OnShow", function(this)

			self:skinTabs{obj=this, regs={}, ignore=true, up=true, lod=true, x1=4, x2=-4}
			self:skinSlider{obj=_G.TalentFrameScrollFrameScrollBar, rt="artwork"}
			self:addSkinFrame{obj=this, ft=ftype, kfs=true, x1=10, y1=-12, x2=-31, y2=71}
			if self.modBtns then
				self:skinStdButton{obj=_G.TalentFrameCancelButton}
			end
			if self.modBtnBs then
				local function colourBtn(btn)
					btn.sbb:SetBackdropBorderColor(_G[btn:GetName() .. "Slot"]:GetVertexColor())
				end
				local btn
				for i = 1, _G.MAX_NUM_TALENTS do
					btn = _G["TalentFrameTalent" .. i]
					btn:DisableDrawLayer("BACKGROUND")
					_G["TalentFrameTalent" .. i .. "RankBorder"]:SetTexture(nil)
					self:addButtonBorder{obj=btn, x1=-3, y2=-3, reParent={_G["TalentFrameTalent" .. i .. "Rank"]}}
					colourBtn(btn)
				end
				btn = nil
				self:SecureHook("TalentFrame_Update", function()
					for i = 1, _G.MAX_NUM_TALENTS do
						colourBtn(_G["TalentFrameTalent" .. i])
					end
				end)
			end

			self:Unhook(this, "OnShow")
		end)

	end

	self.blizzFrames[ftype].Tutorial = function(self)
		if not self.prdb.Tutorial or self.initialized.Tutorial then return end
		self.initialized.Tutorial = true

		self:SecureHookScript(_G.TutorialFrame, "OnShow", function(this)
			this:DisableDrawLayer("BACKGROUND")
			self:addSkinFrame{obj=this, ft=ftype, kfs=true, nb=true}
			if self.modChkBtns then
				self:skinCheckButton{obj=_G.TutorialFrameCheckButton}
			end
			if self.modBtns then
				self:skinStdButton{obj=_G.TutorialFrameOkayButton}
			end
			self:Unhook(this, "OnShow")
		end)

		-- wait for function to be declared
		_G.C_Timer.After(0.5, function()
			local btn
			for i = 1, 10 do
				btn = _G["TutorialFrameAlertButton" .. i]
				self:skinOtherButton{obj=btn, ft=ftype, sap=true, font="ZoneTextFont", text="!"}
			end
			btn = nil
		end)

	end

	self.blizzFrames[ftype].WorldMap = function(self)
		if not self.prdb.WorldMap.skin or self.initialized.WorldMap then return end
		self.initialized.WorldMap = true

		self:SecureHookScript(_G.WorldMapFrame, "OnShow", function(this)
			self:keepFontStrings(_G.WorldMapFrame)
			self:addSkinFrame{obj=_G.WorldMapFrame.BorderFrame, ft="u", kfs=true, nb=true, ofs=1}
			-- make sure map textures are displayed
			_G.WorldMapFrame.BorderFrame.sf:SetFrameStrata("LOW")
			self:skinDropDown{obj=_G.WorldMapContinentDropDown}
			self:skinDropDown{obj=_G.WorldMapZoneDropDown}
			if self.modBtns then
				self:skinStdButton{obj=_G.WorldMapZoomOutButton}
				self:skinCloseButton{obj=_G.WorldMapFrameCloseButton}
			end

			self:Unhook(this, "OnShow")
		end)

	end

	-- TODO:
		-- UnitPopup
		-- WorldStateFrame

	-- VideoOptionsFrame, wait for variable to be populated
	_G.C_Timer.After(1, function()
		if self.modBtns then
			self:skinStdButton{obj=_G.VideoOptionsFrameClassic}
		end
	end)

	-- UnitFrames
	local uFrames = self:GetModule("UnitFrames", true)
	function uFrames:skinPlayerF()

		if self.db.profile.player
		and not self.isSkinned["Player"]
		then

			local pF = _G.PlayerFrame
			_G.PlayerFrameBackground:SetTexture(nil)
			_G.PlayerFrameTexture:SetAlpha(0) -- texture file is changed dependant upon in vehicle or not
			_G.PlayerFrameVehicleTexture:SetAlpha(0) -- texture file is changed dependant upon in vehicle or not
			_G.PlayerStatusTexture:SetTexture(nil)
			pF.threatIndicator = _G.PlayerAttackBackground
			_G.PlayerRestGlow:SetTexture(nil)
			_G.PlayerAttackGlow:SetTexture(nil)

			-- status bars
			aObj:skinStatusBar{obj=pF.healthbar, fi=0}
			aObj:skinStatusBar{obj=pF.manabar, fi=0, nilFuncs=true}
			uFrames:adjustStatusBarPosn(pF.healthbar)

			-- PowerBarAlt handled in MainMenuBar function (UIF)

			-- casting bar handled in CastingBar function (PF)

			-- move level & rest icon down, so they are more visible
			uFrames:SecureHook("PlayerFrame_UpdateLevelTextAnchor", function(level)
				_G.PlayerLevelText:SetPoint("CENTER", _G.PlayerFrameTexture, "CENTER", level == 100 and -62 or -61, -20 + -9)
			end)
			_G.PlayerRestIcon:SetPoint("TOPLEFT", 36, -63)

			-- remove group indicator textures
			aObj:keepFontStrings(_G.PlayerFrameGroupIndicator)
			aObj:moveObject{obj=_G.PlayerFrameGroupIndicatorText, y=-1}

			uFrames:skinUnitButton{obj=pF, ti=true, x1=35, y1=-5, x2=2, y2=2}

			pF = nil

		end

	end
	function uFrames:skinPetF()

		if self.db.profile.pet
		and not self.isSkinned["Pet"]
		then
			_G.PetFrameTexture:SetAlpha(0) -- texture file is changed dependant upon in vehicle or not
			_G.PetFrame.threatIndicator = _G.PetAttackModeTexture
			-- status bars
			uFrames:adjustStatusBarPosn(_G.PetFrameHealthBar, 0)
			aObj:skinStatusBar{obj=_G.PetFrameHealthBar, fi=0}
			uFrames:adjustStatusBarPosn(_G.PetFrameManaBar, -1)
			aObj:skinStatusBar{obj=_G.PetFrameManaBar, fi=0, nilFuncs=true}
			-- casting bar handled in CastingBar function
			aObj:moveObject{obj=_G.PetFrame, x=21, y=-2} -- align under Player Health/Mana bars

			-- skin the PetFrame
			_G.PetPortrait:SetDrawLayer("BORDER") -- move portrait to BORDER layer, so it is displayed
			uFrames:skinUnitButton{obj=_G.PetFrame, ti=true, x1=1}
		end

		if self.db.profile.petspec
		and self.uCls == "HUNTER"
		then
			-- Add pet spec icon to pet frame, if required
			_G.PetFrame.roleIcon = _G.PetFrame:CreateTexture(nil, "artwork")
			_G.PetFrame.roleIcon:SetSize(24, 24)
			_G.PetFrame.roleIcon:SetPoint("left", -10, 0)
			_G.PetFrame.roleIcon:SetTexture([[Interface\LFGFrame\UI-LFG-ICON-ROLES]])
			-- get Pet's Specialization Role to set roleIcon TexCoord
			self:RegisterEvent("UNIT_PET", function(event, arg1)
				if arg1 == "player"
				and _G.UnitIsVisible("pet")
				then
					local petSpec = _G.GetSpecialization(nil, true)
					if petSpec then
						_G.PetFrame.roleIcon:SetTexCoord(_G.GetTexCoordsForRole(_G.GetSpecializationRole(petSpec, nil, true)))
					end
					petSpec = nil
				end
			end)
		end

	end
	uFrames.skinFocusF = _G.nop

end

-- Load support for WoW Classic
local success, err = _G.xpcall(function() return aObj.otherAddons.ClassicInit(aObj) end, _G.geterrorhandler())
if not success then
	aObj:CustomPrint(1, 0, 0, "Error running ClassicInit")
end
